# fb_data

**fb_data** is a Python package maintained by the Data team at FishingBooker which simplifies data workflows by providing helper functions for interacting with:
- **Snowflake**: Streamlined query execution, DataFrame integration, and privilege management.
- **Google Analytics (GA4)**: Query analytics data in raw or DataFrame format.
- **Google Search Console**: Extract search performance data efficiently.

---

## 📦 Installation

Install the package using pip:

```bash
pip install fb_data
```

## 📚 Supported Modules

### 1. Snowflake Helper
The Snowflake module provides methods to interact with your Snowflake database.

Features:

- Execute SQL queries with results in raw or Pandas DataFrame format.
- Write DataFrames to Snowflake tables.
- Manage database, schema, and object privileges.

### 2. Google Analytics Helper
Simplifies interactions with Google Analytics API (GA4).

Features:

- Query analytics data with custom dimensions and metrics.
- Retrieve results in raw or Pandas DataFrame format.

### 3. Google Search Console Helper
Provides easy access to Google Search Console API.

Features:
- Extract search performance data for specific dimensions and metrics.
- Handle large data extractions with pagination support.

## 🤝 Contributing

- Ensure you have Poetry installed for dependency management and packaging.
- This project follows [Semantic Versioning 2.0.0](https://semver.org/). When making changes, increment the version number in the pyproject.toml file based on the nature of the change:
  - Patch: Bug fixes or minor updates (e.g., 1.0.0 → 1.0.1).
  - Minor: New features that are backward-compatible (e.g., 1.0.0 → 1.1.0).
  - Major: Breaking changes (e.g., 1.0.0 → 2.0.0).